#include <SPI.h>
#include <MFRC522.h>
#include <Servo.h>
#include <LiquidCrystal.h>


#define SS_PIN 10
#define RST_PIN 9

#define SERVO_PIN 8
Servo myservo;

#define ACCESS_DELAY 2000
#define DENIED_DELAY 1000
MFRC522 mfrc522(SS_PIN, RST_PIN);// Create MFRC522 instance.
LiquidCrystal lcd(6,7,5,4,3,2);
 
void setup() 
{
  Serial.begin(9600);   // Initiate a serial communication
  SPI.begin();          // Initiate  SPI bus
  mfrc522.PCD_Init(); // Initiate MFRC522
  lcd.begin(16, 2);
  lcd.print("Scan RFID Card");

  myservo.attach(SERVO_PIN);
  myservo.write( 75 );
  Serial.println("Put your card to the reader...");
  Serial.println();

}
void loop() 
{
  // Look for new cards
  if ( ! mfrc522.PICC_IsNewCardPresent()) 
  {
    return;
  }
  // Select one of the cards
  if ( ! mfrc522.PICC_ReadCardSerial()) 
  {
    return;
  }
  //Show UID on serial monitor
  lcd.clear();
  lcd.begin(16, 2);
  lcd.print("UID tag :");
  String content= "";
  byte letter;
  for (byte i = 0; i < mfrc522.uid.size; i++) 
  {
     lcd.setCursor(0,1);
     lcd.print(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " ");
     lcd.print(mfrc522.uid.uidByte[i], HEX);
     content.concat(String(mfrc522.uid.uidByte[i] < 0x10 ? " 0" : " "));
     content.concat(String(mfrc522.uid.uidByte[i], HEX));
  }
  lcd.clear();
  lcd.begin(16,2);
  lcd.print("Message : ");
  content.toUpperCase();
  if (content.substring(1) == "39 AA E3 B3") //change here the UID of the card
  {
    lcd.clear();
    lcd.setCursor(1,0);
    lcd.print("Access Granted");
   myservo.write( 158 );
   delay(7500);
  myservo.write( 75 );
  lcd.clear();
  lcd.print("Scan RFID Card");
  setup();

  }
 
 else   {
   lcd.clear();
   lcd.setCursor(1,0);
    lcd.print(" Access Denied");
    delay(4000);
    lcd.clear();
    delay(DENIED_DELAY);
    lcd.print("Scan RFID Card");
    setup();

 
  }
}


